﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Collections.ObjectModel;
using System.Windows.Input;
using System.Windows;

namespace RadGridView_WPF_AR_82
{
    public class MyViewModel : INotifyPropertyChanged
    {
        public static readonly RoutedUICommand MsgboxCommand = new RoutedUICommand("MsgboxCommand", "MsgboxCommand", typeof(MyCommand));

        public CommandBinding CustomCommandBinding
        {
            get
            {
                return new CommandBinding(MsgboxCommand, new ExecutedRoutedEventHandler(ExecutedMsgbox), new CanExecuteRoutedEventHandler(CanExecuteMsgbox));                
            }
        }

        private void CanExecuteMsgbox(object sender, CanExecuteRoutedEventArgs e)
        {
            e.CanExecute = true;
        }

        private void ExecutedMsgbox(object sender, ExecutedRoutedEventArgs e)
        {
            MessageBox.Show("Command executed");
        }

        public event PropertyChangedEventHandler PropertyChanged;


        private ObservableCollection<Club> clubs;
        private object selectedItem;

        public ObservableCollection<Club> Clubs
        {
            get
            {
                if (this.clubs == null)
                {
                    this.clubs = Club.GetClubs();
                }

                return this.clubs;
            }
        }

        public object SelectedItem
        {
            get { return this.selectedItem; }
            set
            {
                if (value != this.selectedItem)
                {
                    this.selectedItem = value;
                    this.OnPropertyChanged("SelectedItem");
                }
            }
        }

        protected virtual void OnPropertyChanged(PropertyChangedEventArgs args)
        {
            PropertyChangedEventHandler handler = this.PropertyChanged;
            if (handler != null)
            {
                handler(this, args);
            }
        }

        private void OnPropertyChanged(string propertyName)
        {
            this.OnPropertyChanged(new PropertyChangedEventArgs(propertyName));
        }
    }
}
